/*
** pork_conf.c - pork's configuration parser.
** Copyright (C) 2002 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#include <config.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <pork_util.h>
#include <pork_set.h>
#include <pork_command.h>
#include <pork_conf.h>

/*
** XXX: this is very barebones and needs to be
** fleshed out.
*/

int make_pork_dir(const char *pork_dir) {
	struct stat st;
	char *logs_dir;
	size_t len;

	if (stat(pork_dir, &st) != 0) {
		if (mkdir(pork_dir, 0700) != 0)
			return (-1);
	} else {
		if (!S_ISDIR(st.st_mode))
			return (-1);
	}

	len = strlen(pork_dir) + sizeof("/logs");
	logs_dir = xmalloc(len);

	snprintf(logs_dir, len, "%s/logs", pork_dir);

	if (stat(logs_dir, &st) != 0) {
		if (mkdir(logs_dir, 0700) != 0)
			return (-1);
	} else {
		if (!S_ISDIR(st.st_mode)) {
			free(logs_dir);
			return (-1);
		}
	}

	return (0);
}

int read_conf(const char *path) {
	FILE *fp;
	char buf[4096];

	fp = fopen(path, "r");
	if (fp == NULL)
		return (-1);

	while (fgets(buf, sizeof(buf), fp) != NULL) {
		char *p = strchr(buf, '\n');
		if (p == NULL) {
			/* XXX - warning: line is too long */
			fclose(fp);
			return (-1);
		}
		*p = '\0';

		p = buf;
		if (*p == '#')
			continue;

		if (*p == opt_get_char(OPT_CMDCHARS))
			p++;

		if (!blank_str(p))
			run_command(p, CMDSET_MAIN);
	}

	fclose(fp);
	return (0);
}
