/*
** pork_screen_cmd.c - screen management.
** Copyright (C) 2002 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __PORK_SCREEN_CMD_H
#define __PORK_SCREEN_CMD_H

void screen_status_msg(char *fmt, ...);
void screen_redraw_input(struct screen *screen);
void screen_window_swap(struct screen *screen, dlist_t *new_cur);
int screen_goto_window(struct screen *screen, u_int32_t refnum);
void screen_refresh(struct screen *screen);
void screen_clear(struct screen *screen);
void screen_erase(struct screen *screen);
void screen_scroll_pgup(struct screen *screen);
void screen_scroll_pgdown(struct screen *screen);
void screen_scroll_to_end(struct screen *screen);
void screen_scroll_to_start(struct screen *screen);
void screen_scroll_up(struct screen *screen);
void screen_scroll_down(struct screen *screen);
struct imwindow *screen_new_window(	struct screen *scr,
									struct aim_priv *priv,
									char *target);
int screen_close_window(struct screen *screen);
void screen_cycle_fwd(struct screen *screen);
void screen_cycle_bak(struct screen *screen);
void screen_scroll_by(struct screen *screen, int lines);
void screen_draw_cursor(struct screen *scr);
void screen_doupdate(void);
int screen_set_quiet(struct screen *scr, int status);
int screen_get_passwd(char *buf, size_t len);

void screen_buddy_status_msg(char *dest, int timestamp, char *fmt, ...);
void screen_print_multiline(struct imwindow *win, char *msg, int timestamp);
int screen_get_passwd(char *buf, size_t len);

void screen_print_info( char *user,
						char *profile,
						char *away_msg,
						u_int32_t idle_time,
						u_int32_t online_since,
						u_int32_t member_since,
						int print_all);

#endif
